package betterwithmods.common.blocks;

import betterwithmods.util.FluidUtils;
import betterwithmods.util.item.ToolsManager;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.init.Enchantments;
import net.minecraft.item.ItemStack;
import net.minecraft.stats.StatList;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nullable;

public class BlockIce extends net.minecraft.block.BlockIce {
    public BlockIce() {
        super();
        func_149711_c(0.5F);
        func_149713_g(3);
        func_149672_a(SoundType.field_185853_f);
        func_149663_c("ice");
        ToolsManager.setPickaxesAsEffectiveAgainst(this);
    }

    @Override
    public void func_180657_a(World worldIn, EntityPlayer player, BlockPos pos, IBlockState state, @Nullable TileEntity te, ItemStack stack) {
        player.func_71029_a(StatList.func_188055_a(this));
        player.func_71020_j(0.005F);

        if (this.canSilkHarvest(worldIn, pos, state, player) && EnchantmentHelper.func_77506_a(Enchantments.field_185306_r, stack) > 0) {
            java.util.List<ItemStack> items = new java.util.ArrayList<ItemStack>();
            items.add(this.func_180643_i(state));

            net.minecraftforge.event.ForgeEventFactory.fireBlockHarvesting(items, worldIn, pos, state, 0, 1.0f, true, player);
            for (ItemStack is : items)
                func_180635_a(worldIn, pos, is);
        } else {
            if (worldIn.field_73011_w.func_177500_n()) {
                worldIn.func_175698_g(pos);
                return;
            }

            int i = EnchantmentHelper.func_77506_a(Enchantments.field_185308_t, stack);
            harvesters.set(player);
            this.func_176226_b(worldIn, pos, state, i);
            harvesters.set(null);
            Material material = worldIn.func_180495_p(pos.func_177977_b()).func_185904_a();

            if (material.func_76230_c() || material.func_76224_d()) {
                setWater(worldIn, pos);
            }
        }
    }

    @Override
    protected void func_185679_b(World worldIn, BlockPos pos) {
        if (worldIn.field_73011_w.func_177500_n()) {
            worldIn.func_175698_g(pos);
        } else {
            this.func_176226_b(worldIn, pos, worldIn.func_180495_p(pos), 0);
            setWater(worldIn, pos);
        }
    }

    private void setWater(World world, BlockPos pos) {

        FluidUtils.setLiquid(world, pos, Blocks.field_150355_j, 14, true);
        for (EnumFacing facing : EnumFacing.field_176754_o) {
            FluidUtils.setLiquid(world, pos.func_177972_a(facing), Blocks.field_150355_j, 10, false);
        }
        world.func_190524_a(pos, Blocks.field_150355_j, pos);
    }
}
